class_name World extends Node
## Container scene for a game world instance.
##
## A world contains player(s) and the active level, manages player states,
## and transitions between active levels.

@export var initial_level: PackedScene = load("res://levels/debug_level/debug_level.tscn")

@onready var level: Node3D = %Level
@onready var ui: WorldUI = %UI

static var group := "WorldGroup"


func _ready() -> void:
	load_level(initial_level)


## Instantiate and mantle the given level scene.
##
## This will free any currently-loaded level!
func load_level(level_scene: PackedScene) -> void:
	# Remove any currently-loaded level assets
	for c: Node in level.get_children():
		c.queue_free()

	# Load the level
	var instance: Node3D = level_scene.instantiate()
	level.add_child(instance)
	instance.reparent(level)
